Attribute VB_Name = "mdlTextEdit"
Public PrnOrient As Integer
Public MaxStr As Integer
Public currFileName As String
Public UnsavedChanges As Boolean
Public FormatFlag As Boolean
Public Newf As Boolean
Public Searchstr As String
Public lpos As Long

Public PageMarginleft As Integer
Public PageMarginTop As Integer
Public PageMarginRight As Integer
Public PageMarginBottom As Integer

Public HeaderMargin As Integer
Public FooterMargin As Integer

Public flagcut As Boolean
Public flagcopy As Boolean

Public FOpen As Scripting.FileSystemObject
Public FRead As Scripting.TextStream
Public FWrite As Scripting.TextStream

'Private Declare Function PageSetupDlg Lib "comdlg32.dll" Alias "PageSetupDlgA" (pPagesetupdlg As PageSetupDlg) As Long
Public Const WM_COPY = &H301     'copy
Public Const WM_PASTE = &H302    'paste
Public Const WM_CLEAR = &H303    'del
Public Const EM_CANUNDO = &HC6   'redo
Public Const EM_UNDO = &HC7      'undo
Public Const EM_LINEINDEX = &HBB '

' Page Setup
Public Type Margins
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type XY
    x As Long
    y As Long
End Type

Public Type PageSetupDlg
    lStructSize As Long
    hwndOwner As Long
    hDevMode As Long
    hDevNames As Long
    flags As Long
    ptPaperSize As XY
    rtMinMargin As Margins
    rtMargin As Margins
    hInstance As Long
    lCustData As Long
    lpfnPageSetupHook As Long
    lpfnPagePaintHook As Long
    lpPageSetupTemplateName As String
    hPageSetupTemplate As Long
End Type

Public LeftM As Single
Public RightM As Single
Public TopM As Single
Public BottomM As Single
Public gprint As Boolean
Public Const mmToPic = 0.57

Public Function FastReplace(SSrch$, SFind$, SRepl$) As String

    Dim src() As Byte, Dst() As Byte, R() As Byte, f() As Byte
    Dim LenF&, LenR&, LenDst&, I&, j&, OutPos&

    Const ChunkSize& = 4096

    If SSrch = "" Or SFind = "" Then Exit Function

    src = SSrch: f = SFind: R = SRepl
    LenF = UBound(f): LenR = UBound(R)
    LenDst = ChunkSize: ReDim Dst(0 To LenDst - 1)
  
    For I = 0 To UBound(src) Step 2
        For j = 0 To LenF Step 2
            If src(I + j) <> f(j) Then Exit For
        Next j

        If j > LenF Then
            For j = 0 To LenR Step 2
                If OutPos >= LenDst Then
                    LenDst = LenDst + ChunkSize
                    ReDim Preserve Dst(0 To LenDst)
                End If
                Dst(OutPos) = R(j): OutPos = OutPos + 2
            Next j
            I = I + LenF - 1
        Else
            If OutPos >= LenDst Then
                LenDst = LenDst + ChunkSize
                ReDim Preserve Dst(0 To LenDst)
            End If
            Dst(OutPos) = src(I): OutPos = OutPos + 2
        End If
    Next I
  
    ReDim Preserve Dst(0 To OutPos - 2): SSrch = Dst
    FastReplace = SSrch$
End Function

' Ruler
Public Sub DrawRuler(MSize As Integer, HRuler As PictureBox)
    Dim Sincr As Single, RScale As Integer
    'Scalemode   TWIPS 567  /1440  
    RScale = 567 '1440
    Sincr = RScale / MSize
    Do While Sincr < HRuler.ScaleWidth
        For I = 1 To MSize
            If I = MSize Then
                Dim L As Integer
                L = Int(Sincr / RScale)
                If L < 10 Then
                    HRuler.CurrentX = Sincr - 40
                Else
                    HRuler.CurrentX = Sincr - 80
                End If
                HRuler.CurrentY = 0
                HRuler.Print Int(Sincr / RScale)
            End If
            If I = Int(MSize * 0.5) Then
                HRuler.Line (Sincr, HRuler.ScaleHeight - (HRuler.ScaleHeight * 0.5))-(Sincr, HRuler.ScaleHeight)
            Else
                HRuler.Line (Sincr, HRuler.ScaleHeight - (HRuler.ScaleHeight * 0.25))-(Sincr, HRuler.ScaleHeight)
            End If
            Sincr = Sincr + (RScale / MSize)
        Next
    Loop
End Sub

Public Function ShowFormatWindow(Dlg_ As CommonDialog)
    On Error GoTo Cancelled_

    With Dlg_
        .CancelError = True
        
        .flags = &H101&
        
        .FontName = frmEdit.Text.SelFontName
        .FontBold = frmEdit.Text.SelBold
        .FontSize = frmEdit.Text.SelFontSize
        .FontItalic = frmEdit.Text.SelItalic
        .FontUnderline = frmEdit.Text.SelUnderline
        .FontStrikethru = frmEdit.Text.SelStrikeThru
        .Color = frmEdit.Text.SelColor
        
        .ShowFont
        
        Screen.MousePointer = 11
        
        frmEdit.Text.SelFontName = .FontName
        frmEdit.Text.SelBold = .FontBold
        frmEdit.Text.SelFontSize = .FontSize
        frmEdit.Text.SelItalic = .FontItalic
        frmEdit.Text.SelUnderline = .FontUnderline
        frmEdit.Text.SelStrikeThru = .FontStrikethru
        frmEdit.Text.SelColor = .Color
        
        Screen.MousePointer = 0
    End With
    
    Exit Function
Cancelled_:
    'MsgBox Err.Description
    Screen.MousePointer = 0
End Function

Public Function DosToWin(a$) As String
 Dim j As Integer
 Dim c As Integer
 For j = 1 To Len(a$)
    c = Asc(Mid(a$, j, 1))
    If c >= 128 And c < 192 Then
        Mid(a$, j) = Chr(c + 64)
    'ElseIf c = 214 Then
    '    Mid(a$, j) = Chr(167)
    'ElseIf c = 196 Then
    '    Mid(a$, j) = Chr(151)
    ElseIf c = 0 Then
        Mid(a$, j) = " "
    End If
 Next
 DosToWin = a$
End Function

Public Function WinToDos(a$) As String
 Dim j As Integer
 Dim c As Long
 For j = 1 To Len(a$)
    c = Asc(Mid(a$, j, 1))
    If c >= 192 And c < 256 Then
        Mid(a$, j) = Chr$(c - 64)
    'ElseIf c = 167 Then
    '    Mid(a$, j) = Chr$(214)
    'ElseIf c = 151 Then
    '    Mid(a$, j) = Chr$(196)
    ElseIf c = 0 Then
        Mid(a$, j) = " "
    End If
 Next
 WinToDos = a$
End Function


